//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define FileBufferSize    512

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool SendFileData(char *FileName)
{
    FILE *SourceHandle = NULL;

	if( (SourceHandle = fopen(FileName, "rb")) == NULL)
    {
        InsertListBoxItem(MDI.RecvEdit_hWnd, "Failed to open export file for binary read", -1);
        return false;
    }

    int BytesRead = 0;
    int ReceiveSize = 0;

    char *FileBuffer  = NULL;

    dlDataCRC = 0xffffffff;

    FileBuffer = (char *) calloc(FileBufferSize + 1, 1);

    MyClient.RawMode = true;

    do{
        if(MyClient.PeekSizeOfSendData() == 0)
        {
            BytesRead = fread(FileBuffer, sizeof(char), FileBufferSize, SourceHandle);
            dlDataCRC = PartialCRC(dlDataCRC, FileBuffer, BytesRead);
            ClientSend(FileBuffer, BytesRead);
        }
        else Sleep(1);
    } while(BytesRead == FileBufferSize && MyClient.Connected);


    // Wait for all data to be sent before switching from RawMode
    while(MyClient.PeekSizeOfSendData() != 0 && MyClient.Connected)
    {
        Sleep(1);
    }

    MyClient.RawMode = false;

    dlDataCRC = (dlDataCRC ^ 0xffffffff);

    free(FileBuffer);
    FileBuffer = NULL;

    if(SourceHandle) fclose(SourceHandle);
    SourceHandle = NULL;

    Sleep(1000);

    if(MyClient.Connected == false)
    {
        InsertListBoxItem(MDI.RecvEdit_hWnd, "Disconnected during file transfer.", -1);
        return false;
    }

    return true;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

